Index: c/src/lib/libbsp/i386/i386ex/console/console.c
===================================================================
--- c/src/lib/libbsp/i386/i386ex/console/console.c	(revision 39cafa5c1512073cfd998bc13d4d8daa7e734924)
+++ c/src/lib/libbsp/i386/i386ex/console/console.c	(revision 6c58b6fea3054acd2da3ebc741b6a4632c131602)
@@ -1,4 +1,4 @@
 /*
- *  This file contains the Force CPU386 console IO package.
+ *  This file contains the i386ex console IO package.
  *
  *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
@@ -15,10 +15,9 @@
 #define F386_INIT
 
+#include <bsp.h>
+#include <rtems/libio.h>
+ 
 #include <stdlib.h>
-#include <stdio.h>   /* to be removed */
-
-#include <rtems.h>
-#include "console.h"
-#include "bsp.h"
+
 #include "../startup/80386ex.h"
 
@@ -41,10 +40,4 @@
 
    inport_byte( RBR0, ignored );
-
-/*  inport_byte( RBR0, ignored );
- *  inport_byte( RBR0, ignored );
- *  inport_byte( RBR0, ignored );
- *  inport_byte( RBR0, ignored );
- */
 
 }
@@ -64,16 +57,27 @@
   rtems_device_major_number  major,
   rtems_device_minor_number  minor,
-  void                      *arg,
-  rtems_id                   self,
-  rtems_unsigned32          *status
-)
-{
-   /*
-    *  flush the console now and at exit.  Just in case.
-    */
-
-   console_cleanup();
-
-   atexit( console_cleanup );
+  void                      *arg
+)
+{
+  rtems_status_code status;
+
+  /*
+   *  flush the console now and at exit.  Just in case.
+   */
+
+  console_cleanup();
+
+  status = rtems_io_register_name(
+    "/dev/console",
+    major,
+    (rtems_device_minor_number) 0
+  );
+ 
+  if (status != RTEMS_SUCCESSFUL)
+    rtems_fatal_error_occurred(status);
+ 
+  atexit( console_cleanup );
+
+  return RTEMS_SUCCESSFUL;
 }
 
@@ -174,47 +178,103 @@
 
 /*
- * __read  -- read bytes from the serial port. Ignore fd, since
- *            we only have stdin.
- */
-
-int __read(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i = 0;
-
-  for (i = 0; i < nbytes; i++) {
-    *(buf + i) = inbyte();
-    if ((*(buf + i) == '\n') || (*(buf + i) == '\r')) {
-      (*(buf + i++)) = '\n';
-      (*(buf + i)) = 0;
+ *  Open entry point
+ */
+ 
+rtems_device_driver console_open(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ *  Close entry point
+ */
+ 
+rtems_device_driver console_close(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ * read bytes from the serial port. We only have stdin.
+ */
+ 
+rtems_device_driver console_read(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+  int maximum;
+  int count = 0;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    buffer[ count ] = inbyte();
+    if (buffer[ count ] == '\n' || buffer[ count ] == '\r') {
+      buffer[ count++ ]  = '\n';
+      buffer[ count ]  = 0;
       break;
     }
   }
-  return (i);
-}
-
-/*
- * __write -- write bytes to the serial port. Ignore fd, since
- *            stdout and stderr are the same. Since we have no filesystem,
- *            open will only return an error.
- */
-
-int __write(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i;
-
-  for (i = 0; i < nbytes; i++) {
-    if (*(buf + i) == '\n') {
-      outbyte ('\r');
+ 
+  rw_args->bytes_moved = count;
+  return (count >= 0) ? RTEMS_SUCCESSFUL : RTEMS_UNSATISFIED;
+}
+
+/*
+ * write bytes to the serial port. Stdout and stderr are the same.
+ */
+ 
+rtems_device_driver console_write(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  int count;
+  int maximum;
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    if ( buffer[ count ] == '\n') {
+      outbyte('\r');
     }
-    outbyte (*(buf + i));
-  }
-  return (nbytes);
-}
+    outbyte( buffer[ count ] );
+  }
+ 
+  rw_args->bytes_moved = maximum;
+  return 0;
+}
+ 
+/*
+ *  IO Control entry point
+ */
+ 
+rtems_device_driver console_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
